
using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine.Events;
using TMPro;
using UnityEngine.SceneManagement;
using System.Linq;
using UnityEngine.UI;

namespace Mod
{
	public class Mod : MonoBehaviour
	{
		public static Map[] Maps;
		public static Map Vol;
		public static Sprite TemplateSprite = ModAPI.LoadSprite("TEMPLATE.png");
		public static string mapname;
		public static MapSelectionMenuBehaviour mapmenu = UnityEngine.Object.FindObjectOfType<MapSelectionMenuBehaviour>();
		public static bool debounce = false;
		public static Sprite Square = ModAPI.LoadSprite("black.png");
		public static Sprite Lava = ModAPI.LoadSprite("Lava.png");
		public static Sprite Acid = ModAPI.LoadSprite("Acid.png");
		public static AudioClip acidhiss = ModAPI.LoadSound("Hiss.wav");
		public static bool Done = false;
		public static string MapModName = "";
		public static string MapName = "WLLV2";
		public static Sprite CustomSprite1 = ModAPI.LoadSprite("CustomSprite1.png");
        public static Sprite CustomSprite2 = ModAPI.LoadSprite("CustomSprite1.png");
        public static Sprite CustomSprite3 = ModAPI.LoadSprite("CustomSprite3.png");
        public static Sprite CustomSprite4 = ModAPI.LoadSprite("CustomSprite4.png");
        public static Sprite CustomSprite5 = ModAPI.LoadSprite("CustomSprite5.png");
        public static Sprite CustomSprite6 = ModAPI.LoadSprite("CustomSprite6.png");
        public static Sprite CustomSprite7 = ModAPI.LoadSprite("CustomSprite7.png");
        public static Sprite CustomSprite8 = ModAPI.LoadSprite("CustomSprite8.png");
        public static Sprite CustomSprite9 = ModAPI.LoadSprite("CustomSprite9.png");
        public static Sprite CustomSprite10 = ModAPI.LoadSprite("CustomSprite1.png");
        public static Sprite CustomSprite11 = ModAPI.LoadSprite("CustomSprite9.png");
        public static Sprite CustomSprite13 = ModAPI.LoadSprite("CustomSprite13.png");
        public static Sprite CustomSprite14 = ModAPI.LoadSprite("CustomSprite14.png");
        public static Sprite CustomSprite17 = ModAPI.LoadSprite("CustomSprite17.png");
        public static Sprite CustomSprite18 = ModAPI.LoadSprite("CustomSprite18.png");
        public static Sprite CustomSprite19 = ModAPI.LoadSprite("CustomSprite19.png");
        public static Sprite CustomSprite22 = ModAPI.LoadSprite("CustomSprite22.png");
		public static Sprite Himmel = ModAPI.LoadSprite("Himmel.png");
		public static PhysicalProperties phys = ModAPI.FindPhysicalProperties("Soft");

		public static void OnLoad()
		{
			phys.Brittleness = 0f;
			phys.Buoyancy = 0f;
			phys.Flammability = 0f;
			phys.MagneticAttractionIntensity = 0f;
			phys.Conducting = false;
			phys.Burnrate = 0f;
			phys.ImpactIntensityMutliplier = 1f;
			phys.HitVolumeMultiplier = 1f;
			phys.BulletSpeedAbsorptionPower = 0f;
			phys.Softness = 0.1f;
			phys.LodgeStrengthMultiplier = 0.1f;
			phys.SharpForceThresholdMultiplier = 1f;
			// 
			Map MapMod = ScriptableObject.CreateInstance<Map>();
			MapMod.name = MapName;
			MapMod.UniqueIdentity = Guid.NewGuid().ToString();
			MapMod.Description = "Map";
			MapMod.Thumbnail = ModAPI.LoadSprite("TEMPLATE.png");
			MapMod.Preview = ModAPI.LoadSprite("TEMPLATE.png");
			MapMod.Prefab = MapRegistry.GetAllMaps().ElementAt(2).Prefab;
			MapModName = MapMod.name;
			MapRegistry.Register(MapMod);
		}

		public static void RemoveBorders()
		{
			foreach (var render in GameObject.Find("Root").transform.parent.GetComponentsInChildren<SpriteRenderer>())
			{
				if (render.gameObject.layer == LayerMask.NameToLayer("Bounds") && render.gameObject.GetComponent<Undraggable>())
				{
					Destroy(render.gameObject);
				}
			}

			Map eggs = Resources.Load<Map>("Maps/Humongous");
			foreach (MapLightBehaviour light in UnityEngine.Object.FindObjectsOfType<MapLightBehaviour>())
			{
				Destroy(light.gameObject);
			}
			var thing = Instantiate<GameObject>(eggs.Prefab.transform.Find("Lightbulb/BulbGlow/full ambient").gameObject);
			thing.transform.position = new Vector2(500f, 100f);
			thing.transform.localScale = new Vector2(100000f, 100000f);
			thing.GetComponent<SpriteRenderer>().material.SetFloat("_GlowIntensity", 1.2f);
			thing.GetComponent<SpriteRenderer>().material.SetColor("_GlowColour", new Color32(255, 255, 255, 225));
			if (GameObject.Find("Panels"))
			{
				GameObject.Find("Panels").transform.localScale = new Vector2(100000f, 100000f);
			}
			MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();
			mapconfig.GetComponent<BoundingBoxBehaviour>().BoundingBox = new Bounds(new Vector3(500f, 250f, 0f), new Vector3(1500000f, 1500000f, 0f));
		}

		public static void CreateGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, string Layer, bool NoCollision, int Order = 0)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, Mod.Square);
			NewGameobject.tag = "NoClear";
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.position = Pos;
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			NewGameobject.transform.rotation = Rotation;
			if (NoCollision)
			{
				NewGameobject.GetComponent<Collider2D>().enabled = false;
			}
			NewGameobject.transform.parent = GameObject.Find("Root").transform.parent;
			NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = Order;
			NewGameobject.AddComponent<Undraggable>();
			NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
			NewGameobject.AddComponent<ContextMenuOptionComponent>();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			physicalBehaviour.Properties = Mod.phys;
			physicalBehaviour.SpawnSpawnParticles = false;
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
			physicalBehaviour.Deletable = false;
			physicalBehaviour.Disintegratable = false;
			physicalBehaviour.DisplayBloodDecals = false;
			physicalBehaviour.ChargeBurns = false;
			physicalBehaviour.SimulateTemperature = false;
			///NewGameobject.AddComponent<AudioSource>();
			///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
			NewGameobject.AddComponent<TestDelay>();
		}

		public static void CreateCustomGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision, int Order = 0)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
			NewGameobject.tag = "NoClear";
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			NewGameobject.FixColliders();
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			if (NoCollision)
			{
				foreach (var col in NewGameobject.GetComponents<Collider2D>())
				{
					col.enabled = false;
				}
			}
			NewGameobject.transform.parent = GameObject.Find("Root").transform.parent;
			NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = Order;
			NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
			NewGameobject.AddComponent<Undraggable>();
			NewGameobject.AddComponent<ContextMenuOptionComponent>();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			physicalBehaviour.Properties = Mod.phys;
			physicalBehaviour.SpawnSpawnParticles = false;
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
			physicalBehaviour.Deletable = false;
			physicalBehaviour.Disintegratable = false;
			physicalBehaviour.DisplayBloodDecals = false;
			physicalBehaviour.ChargeBurns = false;
			physicalBehaviour.SimulateTemperature = false;
			physicalBehaviour.rigidbody = NewGameobject.GetComponent<Rigidbody2D>();
			///NewGameobject.AddComponent<AudioSource>();
			///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
			NewGameobject.AddComponent<TestDelay>();
		}

		public static void CreateSpawnable(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, bool FacingRight, bool Frozen)
		{
			GameObject NewGameobject = Instantiate<GameObject>(ModAPI.FindSpawnable(Name).Prefab, Vector3.zero, Quaternion.identity);
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			if (!FacingRight)
			{
				NewGameobject.transform.localScale = new Vector2(-NewGameobject.transform.localScale.x, NewGameobject.transform.localScale.y);
			}
			if (Frozen)
			{
				NewGameobject.AddComponent<TestDelay>();
			}
		}

		public static void CreatePhysicsGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Objects");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			NewGameobject.FixColliders();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			if (NoCollision)
			{
				NewGameobject.GetComponent<Collider2D>().enabled = false;
			}
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
		}

		public static void CreateLightSources(String Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Color32 color, float brightness)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			var light = ModAPI.CreateLight(NewGameobject.transform, color, brightness);
			light.gameObject.tag = "NoClear";
		}

		public static void CreateBackground(
			  string Name,
			  Color32 color,
			  Sprite spritey,
			  bool IsTexture)
		{
			GameObject gameObject = new GameObject();
			gameObject.tag = "NoClear";
			gameObject.transform.position = (Vector3)new Vector2(572.314f, 496.2918f);
			Texture2D whiteTexture = Texture2D.whiteTexture;
			whiteTexture.Resize(16, 16);
			whiteTexture.Apply();
			if (IsTexture)
			{
				Texture2D texture1 = new Texture2D((int)spritey.rect.width, (int)spritey.rect.height);
				Texture2D texture2 = spritey.texture;
				int x = (int)spritey.textureRect.x;
				Rect textureRect = spritey.textureRect;
				int y = (int)textureRect.y;
				textureRect = spritey.textureRect;
				int width = (int)textureRect.width;
				textureRect = spritey.textureRect;
				int height = (int)textureRect.height;
				Color[] pixels = texture2.GetPixels(x, y, width, height);
				texture1.SetPixels(pixels);
				texture1.wrapMode = TextureWrapMode.Repeat;
				texture1.filterMode = FilterMode.Point;
				texture1.Apply();
				Sprite sprite = Sprite.Create(texture1, new Rect(0.0f, 0.0f, (float)texture1.width, (float)texture1.height), 0.5f * Vector2.one, 140f, 0U, SpriteMeshType.FullRect);
				gameObject.AddComponent<SpriteRenderer>().drawMode = SpriteDrawMode.Tiled;
				gameObject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
				gameObject.GetComponent<SpriteRenderer>().sprite = sprite;
				gameObject.GetComponent<SpriteRenderer>().size = new Vector2(5f, 5f);
				gameObject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
				gameObject.GetComponent<SpriteRenderer>().sortingOrder = -999999;
			}
			else
			{
				gameObject.AddComponent<SpriteRenderer>().sprite = Sprite.Create(whiteTexture, new Rect(0.0f, 0.0f, 16f, 16f), 0.5f * Vector2.one, 35f);
				gameObject.GetComponent<SpriteRenderer>().color = (Color)color;
				gameObject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
				gameObject.GetComponent<SpriteRenderer>().sortingOrder = -999999;
			}
			gameObject.transform.localScale = (Vector3)new Vector2(2533.112f, 2175.462f);
			gameObject.transform.parent = GameObject.Find("Root").transform.parent;
			gameObject.layer = LayerMask.NameToLayer("Bounds");
		}

		public static void CreateParticleSources(string Name, Vector2 Pos, float Speed, string Particles)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.name = Name;
			NewGameobject.transform.position = Pos;
			NewGameobject.AddComponent<ParticleDelay>();
			NewGameobject.GetComponent<ParticleDelay>().Speed1 = Speed;
			NewGameobject.GetComponent<ParticleDelay>().Particles1 = Particles;
		}

		public static void AddAudioToAmbience(float Bacon, AudioClip[] Eggs)
		{
			///Changing this to other variables in the MapConfig will let you force snow on and other stuff.
			MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();
			///mapconfig.OverrideAmbientSounds = true;
			var hhh = mapconfig.transform.parent.GetComponent<PlayAudioAtRandom>();
			hhh.Clips = Eggs;
			hhh.ChancePerSecond = Bacon;
		}

		public static void CreateWaterBlock(Vector3 Size, Vector3 Pos, Quaternion Rotation, string Type)
		{
			Map eggs = Resources.Load<Map>("Maps/Sea");
			GameObject WaterBefore = eggs.Prefab.transform.Find("Root/Sea").gameObject;
			var Water = Instantiate<GameObject>(WaterBefore, Vector3.zero, Quaternion.identity);
			Water.transform.rotation = Rotation;
			Water.transform.localScale = new Vector2(Size.x, -Size.y);
			///Water.transform.SetParent(GameObject.Find("Root").transform);
			Water.transform.localPosition = Pos;
			Water.AddComponent<WaterBlockBehaviour>().GlobalTop = Water.GetComponent<SpriteRenderer>().bounds.max.y;
			Water.GetComponent<WaterBlockBehaviour>().GlobalBottom = Water.GetComponent<SpriteRenderer>().bounds.min.y;
			Water.GetComponent<WaterBlockBehaviour>().GlobalLeft = Water.GetComponent<SpriteRenderer>().bounds.min.x;
			Water.GetComponent<WaterBlockBehaviour>().GlobalRight = Water.GetComponent<SpriteRenderer>().bounds.max.x;
			Water.GetComponent<WaterBlockBehaviour>().WaterSize = Size;
			Water.GetComponent<WaterBlockBehaviour>().WaterCenter = Pos;
			Water.GetComponent<WaterBlockBehaviour>().Drag = Water.GetComponent<WaterBehaviour>().Drag;
			Water.GetComponent<WaterBlockBehaviour>().Buoyancy = Water.GetComponent<WaterBehaviour>().Buoyancy;
			Water.GetComponent<WaterBlockBehaviour>().Trigger = Water.GetComponent<WaterBehaviour>().Trigger;
			Water.GetComponent<WaterBlockBehaviour>().Splash = UnityEngine.Object.Instantiate<GameObject>(Water.GetComponent<WaterBehaviour>().Splash);
			Water.GetComponent<WaterBlockBehaviour>().Splash.SetActive(false);
			Water.GetComponent<WaterBlockBehaviour>().Layers = Water.GetComponent<WaterBehaviour>().Layers;
			Water.GetComponent<WaterBlockBehaviour>().ObjectsToBeActiveIfWater = Water.GetComponent<WaterBehaviour>().ObjectsToBeActiveIfWater;
			Water.GetComponent<WaterBlockBehaviour>().BoilingWaterSound = Water.GetComponent<WaterBehaviour>().BoilingWaterSound;
			Water.GetComponent<WaterBlockBehaviour>().Ice = Water.GetComponent<WaterBehaviour>().Ice;
			Water.GetComponent<WaterBehaviour>().enabled = false;
			WaterBlockBehaviour.Instance = Water.GetComponent<WaterBlockBehaviour>();
			var main = Water.GetComponentInChildren<ParticleSystem>().main;
			var shape = Water.GetComponentInChildren<ParticleSystem>().shape;
			var emission = Water.GetComponentInChildren<ParticleSystem>().emission;
			main.scalingMode = ParticleSystemScalingMode.Shape;
			shape.scale = Size;
			shape.rotation = Water.transform.eulerAngles;
			emission.rateOverTimeMultiplier = 1f * (Size.x / 4.8f);
			if (Type == "Lava")
			{
				Water.GetComponent<SpriteRenderer>().drawMode = SpriteDrawMode.Tiled;
				Water.GetComponent<SpriteRenderer>().tileMode = SpriteTileMode.Continuous;
				Water.GetComponent<SpriteRenderer>().sprite = Mod.Lava;
				Water.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
				Water.GetComponent<WaterBlockBehaviour>().Lava = true;
				var light = ModAPI.CreateLight(Water.transform, new Color32(255, 129, 32, 255), 15, 5);
				Water.AddComponent<LavaBurn>();
				foreach (var particle in Water.GetComponent<WaterBlockBehaviour>().Splash.GetComponentsInChildren<ParticleSystem>())
				{
					var shape2 = particle.shape;
					var main2 = particle.main;
					shape2.texture = Mod.Lava.texture;
					main2.startColor = new Color(1f, 0.5f, 0.12f, 1f);
				}
				Water.GetComponent<WaterBlockBehaviour>().Buoyancy = 0f;
				Water.GetComponent<WaterBlockBehaviour>().Drag += 0.6f;
			}
			else if (Type == "Acid")
			{
				Water.GetComponent<SpriteRenderer>().color = new Color(0, 1, 0, 1);
				Water.GetComponent<SpriteRenderer>().drawMode = SpriteDrawMode.Tiled;
				Water.GetComponent<SpriteRenderer>().tileMode = SpriteTileMode.Continuous;
				Water.GetComponent<SpriteRenderer>().sprite = Mod.Acid;
				Water.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
				var AcidLight = ModAPI.CreateLight(Water.transform, new Color(0, 1, 0, 1), 4, 3);
				Water.GetComponent<WaterBlockBehaviour>().Lava = true;
				Water.AddComponent<AcidBurn>();
				foreach (var particle in Water.GetComponent<WaterBlockBehaviour>().Splash.GetComponentsInChildren<ParticleSystem>())
				{
					var shape2 = particle.shape;
					var main2 = particle.main;
					shape2.texture = Mod.Acid.texture;
					main2.startColor = new Color(0, 1, 0, 0.8f);
				}
				Water.GetComponent<WaterBlockBehaviour>().Buoyancy -= 0.1f;
				Water.GetComponent<WaterBlockBehaviour>().Drag += 0.4f;
			}
			GameObject.Destroy(Water.GetComponent<WaterBehaviour>());
		}

		public static void Main()
		{
			///Don't do anything yet.
			if (MapLoaderBehaviour.CurrentMap.name == MapModName)
			{
				Debug.Log("Setting up some stuff.");
				var manager = new GameObject("managerMap");
				manager.AddComponent<MapModManager>();
			}
		}
		public static void InitilizeMap()
		{
			foreach (var waterBlock in GameObject.FindObjectsOfType<WaterBlockBehaviour>())
			{
				GameObject.Destroy(waterBlock.gameObject);
			}
			
			CreateGameObjects("Other", new Vector2(188.0119f, -16.95918f), new Vector2(9617f, 4127f), Quaternion.Euler(0f, 0f, 348.1f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(2.752426f, 6.941799f), new Vector2(-4438f, 4562f), Quaternion.Euler(0f, 0f, 351.6f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(105.1684f, 68.95849f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 350.9f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(45f, 75f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(24f, 99f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(84f, 99f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(201.6747f, 52.90419f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 345.3f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(138f, 75f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(24f, 87f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(83.8632f, 87.27359f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0.6999995f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(228f, 75f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(149.5388f, 66.48775f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 351.6f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(261f, 63f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(288f, 75f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(6f, 111f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(60.82418f, 99.1074f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 335.5f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(141.2882f, 91.26197f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 344.6f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(196.1185f, 70.5779f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 334.1f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(185.8368f, 76.6358f), new Vector2(-1f, -1f), Quaternion.Euler(0f, 0f, 353.7f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(502.4391f, 28.86238f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 343.9f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(58.14348f, 101.7997f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 353.7f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(339f, 75f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(396.8161f, 68.26109f), new Vector2(-1f, -1f), Quaternion.Euler(0f, 0f, 346.7f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(396.0321f, 68.21488f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 355.1f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(449.5591f, 51.66957f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 330.6f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(549.713f, 17.51249f), new Vector2(-1f, -1f), Quaternion.Euler(0f, 0f, 350.9f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(321f, 63f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(381f, 63f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(408f, 54f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(429f, 33f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(444f, 33f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(432f, 45f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(458.4028f, 25.3139f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(468.9833f, 20.839f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(348f, 54f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(586.6473f, 12.97458f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 1.399998f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(645.2839f, 17.55296f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 7.7f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(703.1461f, 19.45246f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 355.8f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(760.6291f, 22.9875f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 11.9f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(816.0538f, 39.87508f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 21.7f), CustomSprite1, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(845.8845f, 55.38692f), new Vector2(-1f, -1f), Quaternion.Euler(0f, 0f, 43.40001f), CustomSprite1, "Front", false, 0);
                CreateWaterBlock(new Vector3(-498.8f, 82.2f, 1f), new Vector3(617.3481f, 36.55605f, 0f), Quaternion.Euler(0f, 0f, 0f), "Water");
                CreateCustomGameObjects("Custom", new Vector2(894.1163f, 79.1829f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 9.100002f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(974.5219f, 108.6047f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 34.3f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1026.476f, 128.9116f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 8.400002f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1068.459f, 149.2056f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 39.9f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1089.346f, 173.9198f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 50.40001f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(-0.5203724f, 112.7088f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 356.5f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(935.4061f, 90.95011f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 19.6f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1134.31f, 197.7881f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 5.599999f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(372f, 45f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(369f, 33f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1134f, 189.0654f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1126.678f, 178.8167f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1116f, 168f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1134f, 168f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1107f, 156f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1095f, 144f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1086f, 138f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1077f, 129f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1050f, 120f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1020f, 117f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1014f, 108f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1074f, 108f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1098f, 120f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1005f, 102f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1035f, 99f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1020f, 87f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(990f, 96f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, -2);
                CreateCustomGameObjects("Custom", new Vector2(960.9468f, 86.67581f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(935.4348f, 77.03183f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(993f, 75f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1053f, 87f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1080f, 99f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1101f, 111f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1113f, 132f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1125f, 144f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1146f, 156f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(894f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(951f, 66f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(885f, 63f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(876f, 54f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(918f, 57f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(927f, 45f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(876f, 42f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(924f, 33f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(864f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(912f, 21f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(795f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(852f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(810f, 24f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(831f, 33f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(867f, 42f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(870f, 24f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(960f, 45f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(975f, 57f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1005f, 66f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(180.8697f, 49.84271f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 346.7f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1005f, 57f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1065f, 87f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1059f, 66f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(678f, 12f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(738f, 12f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(777f, 6f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(723f, 6f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(663f, 6f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(609f, 6f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(555.7639f, 6.327305f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 354.4f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(505.9638f, 15.81896f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 346.7f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(297f, 51f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(318f, 42f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(318f, 33f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(77.11879f, 70.66624f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 353.7f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(285f, 21f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(261f, 33f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(258f, 45f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(237f, 54f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(193.8118f, 65.35242f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 349.5f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(234f, 39f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(399f, 21f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(426f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(124.0487f, 62.12295f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 347.4f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(837f, 3f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(897f, 3f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(912f, 12f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(126f, 87f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(369f, 12f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateGameObjects("Other", new Vector2(364.5982f, -7.746002f), new Vector2(-13118f, 1962f), Quaternion.Euler(0f, 0f, 353f), "Front", false, 10);
                CreateGameObjects("Other", new Vector2(1030.715f, -7.003895f), new Vector2(-16418f, 5682f), Quaternion.Euler(0f, 0f, 26.6f), "Front", false, 10);
                CreateGameObjects("Other", new Vector2(896.6049f, -15.91609f), new Vector2(-7102f, -2642f), Quaternion.Euler(0f, 0f, 12.6f), "Front", false, 10);
                CreateCustomGameObjects("Custom", new Vector2(1133.669f, 203.9867f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 5.6f), CustomSprite3, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(-1.519205f, 118.7459f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 356.5f), CustomSprite3, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(142.8051f, 97.17097f), new Vector2(-1f, -1f), Quaternion.Euler(0f, 0f, 344.6f), CustomSprite3, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(339.0122f, 81.06519f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(279f, 81f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(243f, 81f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(934.0197f, 97.1762f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 19.6f), CustomSprite3, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(1085.052f, 178.0755f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 50.40001f), CustomSprite3, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(69.61609f, 106.7811f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 353.7f), CustomSprite4, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(99.35876f, 105.1178f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(214.3517f, 81.11755f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 359.3f), CustomSprite4, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(878.317f, 82.92177f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 9.1f), CustomSprite4, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(891.2432f, 84.88753f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 9.1f), CustomSprite4, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(973.6902f, 115.3324f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 34.3f), CustomSprite4, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(983.6133f, 122.1261f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 34.3f), CustomSprite4, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(1010.511f, 132.742f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 8.4f), CustomSprite4, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(1030.561f, 135.7239f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 8.399999f), CustomSprite4, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(1055.981f, 146.8956f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 39.90005f), CustomSprite4, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(42.65781f, 113.9587f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 334.8f), CustomSprite5, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(28.77707f, 117.1874f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 359.3f), CustomSprite5, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(48.69527f, 111.3313f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 335.5f), CustomSprite5, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(192.3322f, 82.03357f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 353.7f), CustomSprite5, "Front", true, 1);
                CreateCustomGameObjects("Custom", new Vector2(178.3309f, 86.04014f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 334.8f), CustomSprite5, "Front", true, 1);

                CreateCustomGameObjects("Custom", new Vector2(1041.483f, 140.312f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 9.8f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(1125.478f, 205.2099f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 18.2f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(1049.573f, 142.6312f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 21f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(378.8119f, 82.56601f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 346f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(367.6597f, 85.59859f), new Vector2(-3f, 3f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(159.3429f, 98.13697f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 347.4f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(71.62591f, 113.2291f), new Vector2(-2f, 2f), Quaternion.Euler(0f, 0f, 343.9f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(117.8107f, 109.0767f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 7.7f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(152.9403f, 96.69655f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 337.6f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(12.9583f, 119.6765f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 350.2f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(88.0679f, 112.5698f), new Vector2(3f, 3f), Quaternion.Euler(0f, 0f, 0.7000021f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(78f, 111f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 337.6f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(45f, 117f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 11.2f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(185.4562f, 87.6864f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(193.7354f, 81.17286f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(6.547527f, 118.7484f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 339.7f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(197.3239f, 81.31966f), new Vector2(-2f, 2f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(946.5814f, 107.2278f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 15.4f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(973.6205f, 119.11f), new Vector2(-2f, 2f), Quaternion.Euler(0f, 0f, 20.3f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(1087.608f, 184.5426f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 34.3f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(1145.745f, 211.2588f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(1133.483f, 204.3977f), new Vector2(-2f, 2f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(1068.785f, 165.7257f), new Vector2(-2f, 2f), Quaternion.Euler(0f, 0f, 8.400002f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(914.2693f, 93.15697f), new Vector2(-2f, 2f), Quaternion.Euler(0f, 0f, 9.100002f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(21f, 123f), new Vector2(3f, 3f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(133.3032f, 107.7574f), new Vector2(-3f, 3f), Quaternion.Euler(0f, 0f, 339f), CustomSprite6, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(66.13034f, 112.196f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(31.41645f, 120.2359f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(1037.314f, 143.6787f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 9.8f), CustomSprite7, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(1141.496f, 206.0806f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(1060.444f, 156.7794f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 39.2f), CustomSprite7, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(1020.25f, 136.7379f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 20.3f), CustomSprite7, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(961.3201f, 113.5466f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 22.4f), CustomSprite7, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(348f, 87f), new Vector2(3f, 3f), Quaternion.Euler(0f, 0f, 4.200003f), CustomSprite7, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(284.7139f, 83.23425f), new Vector2(-3f, 3f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(0.7144241f, 124.7252f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(172.0213f, 93.21914f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 341.1f), CustomSprite7, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(146.0899f, 101.6791f), new Vector2(-2f, 2f), Quaternion.Euler(0f, 0f, 347.4f), CustomSprite7, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(1024.914f, 140.4925f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 26.6f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(1078.945f, 174.6904f), new Vector2(-2f, 2f), Quaternion.Euler(0f, 0f, 41.3f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(931.9597f, 99.99519f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 21.7f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(942.6297f, 105.467f), new Vector2(-2f, 2f), Quaternion.Euler(0f, 0f, 11.2f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(52.31057f, 113.5369f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 341.1f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(105f, 111f), new Vector2(-3f, 3f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(302.6512f, 85.00816f), new Vector2(2f, 2f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(1119.448f, 208.1973f), new Vector2(-2f, 2f), Quaternion.Euler(0f, 0f, 7.699999f), CustomSprite8, "Back", true, -9000);

                CreateCustomGameObjects("Custom", new Vector2(294.2881f, 14.57386f), new Vector2(-124676f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite9, "Front", true, 9999);
                CreateCustomGameObjects("Custom", new Vector2(8.772602f, 500.8703f), new Vector2(-130499f, 1f), Quaternion.Euler(0f, 0f, 270f), CustomSprite9, "Front", true, 9999);
                CreateCustomGameObjects("Custom", new Vector2(1139.42f, 150.8806f), new Vector2(-50799f, 1f), Quaternion.Euler(0f, 0f, 26.6f), CustomSprite9, "Front", true, 9999);
                CreateCustomGameObjects("Custom", new Vector2(341.96f, 31.98814f), new Vector2(-19499f, 1f), Quaternion.Euler(0f, 0f, 350.9f), CustomSprite9, "Front", true, 9999);
                CreateCustomGameObjects("Custom", new Vector2(-17.60423f, 89.19405f), new Vector2(-5999f, 1f), Quaternion.Euler(0f, 0f, 351.6f), CustomSprite9, "Front", true, 9999);
                CreateCustomGameObjects("Custom", new Vector2(911.3408f, 39.83302f), new Vector2(-9999f, 1f), Quaternion.Euler(0f, 0f, 16.8f), CustomSprite9, "Front", true, 9999);
                CreateCustomGameObjects("Custom", new Vector2(225f, 63f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(99f, 75.54718f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(345f, 24f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1136.102f, 292.2707f), new Vector2(-122499f, 1f), Quaternion.Euler(0f, 0f, 90f), CustomSprite11, "Front", true, 9999);
                CreateCustomGameObjects("Custom", new Vector2(574.4751f, 978.3849f), new Vector2(140999f, -1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Front", true, 9999);
                CreateCustomGameObjects("Custom", new Vector2(511.5475f, 37.56578f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 329.2f), CustomSprite13, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(625.9742f, 26.64538f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 4.900001f), CustomSprite13, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(567.1776f, 24.60183f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 348.1f), CustomSprite13, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(764.2999f, 27.461f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 11.2f), CustomSprite13, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(682.3647f, 30.77663f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 350.9f), CustomSprite13, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(487.9503f, 43.84311f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 6.3f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(533.555f, 31.26503f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 348.8f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(455.3627f, 61.10471f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 339.7f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(446.1254f, 65.79399f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(606.4474f, 22.2899f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 4.899998f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(712.2911f, 26.06149f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 346.7f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(664.9495f, 27.20917f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 16.8f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(794.9238f, 42.41587f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 348.8f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(839.1093f, 60.49175f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 15.4f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(819.312f, 48.7281f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(733.8101f, 29.2176f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 11.2f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(615.0779f, 20.23502f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 346f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(567.446f, 20.85621f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 4.2f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(577.3066f, 19.35204f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 348.8f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(638.1417f, 24.36592f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 5.599999f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(499.8104f, 39.24043f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 11.9f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(496.4677f, 36.23209f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 336.9f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(421.761f, 70.99497f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(402.8754f, 71.32922f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 355.8f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(412.4017f, 70.82784f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(628.8328f, 21.69185f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 353f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(672.6207f, 27.37425f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 353.7f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(691.3391f, 26.37146f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 346f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(619.3064f, 24.70017f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(678.8044f, 31.55249f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 5.599999f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(768.0515f, 28.37702f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 354.4f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(757.6894f, 30.88396f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 9.1f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(773.7339f, 37.06774f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 350.2f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(791.2361f, 40.74458f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 19.6f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(823.1578f, 52.10938f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 353f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(510.5079f, 35.06219f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 346.7f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(439.1437f, 63.30702f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 346.7f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(14.6213f, 439.3954f), new Vector2(0.25f, 0.25f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Back", true, -250);
                CreateCustomGameObjects("Custom", new Vector2(1106.7f, 971.1f), new Vector2(0.75f, 0.75f), Quaternion.Euler(0f, 0f, 0f), CustomSprite18, "Back", true, -250);
                CreateCustomGameObjects("Custom", new Vector2(581.4766f, 973.7494f), new Vector2(0.5f, -0.5f), Quaternion.Euler(0f, 0f, 0f), CustomSprite18, "Back", true, -250);
                CreateCustomGameObjects("Custom", new Vector2(792.4772f, 970.7865f), new Vector2(0.75f, 0.5f), Quaternion.Euler(0f, 0f, 0f), CustomSprite19, "Back", true, -250);
                CreateCustomGameObjects("Custom", new Vector2(59.72532f, 971.5062f), new Vector2(-0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), CustomSprite19, "Back", true, -250);
                CreateCustomGameObjects("Custom", new Vector2(1107.314f, 202.8802f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 359.6001f), CustomSprite22, "Back", true, -250);
			SpriteRenderer SPR;
            SPR = new GameObject("Hintergrund").AddComponent<SpriteRenderer>();
			SPR.gameObject.transform.position =new Vector3(565.6798f, 481.7658f,0);
            SPR.gameObject.transform.localScale =new Vector3(-43139f, 139f,1f);
            SPR.sortingLayerName = "Bottom";
            SPR.sortingOrder = -2;
            SPR.sprite = Himmel;
			AddAudioToAmbience(1E-07f, new AudioClip[1]
				{

ModAPI.LoadSound("Deep drilling.wav")
});
			AddAudioToAmbience(1E-06f, new AudioClip[1]
{
		ModAPI.LoadSound("Wake Up Part 2.wav")
});
			AddAudioToAmbience(1E-05f, new AudioClip[1]
{
		ModAPI.LoadSound("Nuclear.wav")
});
		}
	}
	public class MapModManager : MonoBehaviour
	{
		private void Start()
		{
			var clearButton = GameObject.Find("Canvas/Catalog/settings/clear/Clear Everything");
			clearButton.GetComponent<Button>().onClick.AddListener(() => Mod.InitilizeMap());
			Mod.InitilizeMap();
		}
		private void OnDestroy()
		{
			if(MapLoaderBehaviour.CurrentMap.name == Mod.MapModName)
			{
				var manager = new GameObject("managerMap");
				manager.AddComponent<MapModManager>();
			}
		}
	}

	public class TestDelay : MonoBehaviour
	{
		public void Awake()
		{
			StartCoroutine(Delay());
		}

		public IEnumerator Delay()
		{
			yield return new WaitForSeconds(0f);
			foreach (var Rig in this.gameObject.GetComponentsInChildren<Rigidbody2D>())
			{
				Rig.bodyType = RigidbodyType2D.Static;
			}
		}
	}

	public class ParticleDelay : MonoBehaviour
	{
		public string Particles1;
		public float Speed1;
		public void Awake()
		{
			StartCoroutine(Emit());
		}

		public IEnumerator Emit()
		{
			yield return new WaitForSeconds(0.25f);
			while (true)
			{
				var time = 1f / Speed1;
				ModAPI.CreateParticleEffect(Particles1.ToString(), gameObject.transform.position);
				yield return new WaitForSeconds(time);
			}
		}
	}

	public class LavaBurn : MonoBehaviour
	{
		private void FixedUpdate()
		{
			foreach (PhysicalBehaviour physicalBehaviour in Global.main.PhysicalObjectsInWorld)
			{
				if (!physicalBehaviour)
				{
					break;
				}
				foreach (Vector2 v in physicalBehaviour.LocalColliderGridPoints)
				{
					Vector3 vector = physicalBehaviour.transform.TransformPoint(v);
					if (vector.y <= gameObject.GetComponent<WaterBlockBehaviour>().GlobalTop && vector.y >= gameObject.GetComponent<WaterBlockBehaviour>().GlobalBottom && vector.x >= gameObject.GetComponent<WaterBlockBehaviour>().GlobalLeft && vector.x <= gameObject.GetComponent<WaterBlockBehaviour>().GlobalRight)
					{
						if (physicalBehaviour.BurnProgress < 0.95f)
						{
							if (physicalBehaviour.Properties.Flammability > 0.1f)
							{
								physicalBehaviour.BurnProgress += 0.01f;
								physicalBehaviour.Ignite();
								physicalBehaviour.burnIntensity = 2f;
							}
							physicalBehaviour.Temperature += 10f;
							if (physicalBehaviour.gameObject.GetComponent<LimbBehaviour>())
							{
								physicalBehaviour.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().AddPain(5f);
							}
						}
					}
				}
			}
		}
	}

	public class AcidBurn : MonoBehaviour
	{
		public float a = 1;
		public float b = 1;
		public Color ACIDCOLOR = new Color(1, 1, 1, 1);

		private void FixedUpdate()
		{
			foreach (PhysicalBehaviour physicalBehaviour in Global.main.PhysicalObjectsInWorld)
			{
				if (!physicalBehaviour)
				{
					break;
				}
				if (physicalBehaviour.transform.root.gameObject.GetComponent<WaterBlockBehaviour>())
				{
					continue;
				}
				foreach (Vector2 v in physicalBehaviour.LocalColliderGridPoints)
				{
					Vector3 vector = physicalBehaviour.transform.TransformPoint(v);
					if (vector.y <= gameObject.GetComponent<WaterBlockBehaviour>().GlobalTop && vector.y >= gameObject.GetComponent<WaterBlockBehaviour>().GlobalBottom && vector.x >= gameObject.GetComponent<WaterBlockBehaviour>().GlobalLeft && vector.x <= gameObject.GetComponent<WaterBlockBehaviour>().GlobalRight)
					{
						if (physicalBehaviour.gameObject.GetComponent<LimbBehaviour>() != null && !physicalBehaviour.isDisintegrated)
						{
							float random = UnityEngine.Random.Range(1f, 10f);
							var limb = physicalBehaviour.gameObject.GetComponent<LimbBehaviour>();
							var skin = physicalBehaviour.gameObject.GetComponent<SkinMaterialHandler>();
							if (physicalBehaviour.gameObject.name == "Head" || physicalBehaviour.gameObject.name == "Foot" || physicalBehaviour.gameObject.name == "FootFront")
							{
								limb.SkinMaterialHandler.AcidProgress += Time.deltaTime * 0.025f;
								limb.SkinMaterialHandler.RottenProgress += Time.deltaTime * 0.025f;
							}
							else
							{
								limb.SkinMaterialHandler.AcidProgress += Time.deltaTime * 0.005f;
								limb.SkinMaterialHandler.RottenProgress += Time.deltaTime * 0.005f;
							}
							limb.Wince(limb.SkinMaterialHandler.AcidProgress * 100f);
							if (limb.SkinMaterialHandler.AcidProgress > 0.75f)
							{
								limb.BreakBone();
								limb.Health = 0f;
							}
							physicalBehaviour.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().AddPain(10f);
							if (limb.Person.OxygenLevel <= 0.7f && !physicalBehaviour.isDisintegrated && physicalBehaviour.gameObject.name != "Head")
							{
								if (limb.Health <= 0f)
								{
									if (skin.RottenProgress >= 0.7f)
									{
										if (skin.AcidProgress >= 0.9f)
										{
											if (physicalBehaviour.gameObject.transform.lossyScale.x < 0f && physicalBehaviour.gameObject.GetComponent<LimbBehaviour>() == null)
											{
												physicalBehaviour.gameObject.transform.localScale = new Vector2(Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.x + 0.005f, -500000f, 0f), Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.y - 0.005f, 0f, 5000000f));
												if (physicalBehaviour.gameObject.transform.localScale.x == 0 && physicalBehaviour.gameObject.transform.localScale.y == 0)
												{
													AudioSource.PlayClipAtPoint(Mod.acidhiss, physicalBehaviour.gameObject.transform.position, 6f);
													physicalBehaviour.Disintegrate();
													break;
												}
											}
											else
											{
												physicalBehaviour.gameObject.transform.localScale = new Vector2(Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.x - 0.005f, 0, 5000000f), Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.y - 0.005f, 0f, 5000000f));
												if (physicalBehaviour.gameObject.transform.localScale.x == 0 && physicalBehaviour.gameObject.transform.localScale.y == 0)
												{
													AudioSource.PlayClipAtPoint(Mod.acidhiss, physicalBehaviour.gameObject.gameObject.transform.position, 6f);
													physicalBehaviour.Disintegrate();
													break;
												}
											}
										}
									}
								}
							}
						}
						else if (physicalBehaviour.Properties.Flammability > 0.1f && !physicalBehaviour.isDisintegrated)
						{
							if (physicalBehaviour.gameObject.transform.lossyScale.x < 0f && physicalBehaviour.gameObject.GetComponent<LimbBehaviour>() == null)
							{
								physicalBehaviour.gameObject.transform.localScale = new Vector2(Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.x + 0.0005f, -500000f, 0f), Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.y - 0.0005f, 0f, 5000000f));
								if (physicalBehaviour.gameObject.transform.localScale.x == 0 && physicalBehaviour.gameObject.transform.localScale.y == 0)
								{
									AudioSource.PlayClipAtPoint(Mod.acidhiss, physicalBehaviour.gameObject.transform.position, 6f);
									physicalBehaviour.Disintegrate();
									a = 1;
									b = 1;
									break;
								}
							}
							else
							{
								physicalBehaviour.gameObject.transform.localScale = new Vector2(Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.x - 0.0005f, 0, 5000000f), Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.y - 0.0005f, 0f, 5000000f));
								if (physicalBehaviour.gameObject.transform.localScale.x == 0 && physicalBehaviour.gameObject.transform.localScale.y == 0)
								{
									AudioSource.PlayClipAtPoint(Mod.acidhiss, physicalBehaviour.gameObject.gameObject.transform.position, 6f);
									physicalBehaviour.Disintegrate();
									a = 1;
									b = 1;
									break;
								}
							}
						}
					}
				}
			}
		}
	}

	public class WaterBlockBehaviour : MonoBehaviour
	{
		public bool IsEvaporated
		{
			get
			{
				if (this.Lava == false)
				{
					return PhysicalBehaviour.AmbientTemperature > 200f;
				}
				else
				{
					return false;
				}
			}
		}

		public bool IsFrozen
		{
			get
			{
				if (this.Lava == false)
				{
					return PhysicalBehaviour.AmbientTemperature < 0f;
				}
				else
				{
					return false;
				}
			}
		}

		private void Awake()
		{
			if (base.gameObject.activeInHierarchy)
			{
				WaterBlockBehaviour.Instance = this;
			}
		}

		private void Start()
		{
			this.SpriteRenderer = base.GetComponent<SpriteRenderer>();
			if (base.gameObject.activeInHierarchy)
			{
				this.waterSizzles = Resources.LoadAll<AudioClip>("Audio/water_sizzle");
				WaterBlockBehaviour.Instance = this;
			}
			UpdateTemperatureState();
		}

		public static bool IsPointUnderWater(Vector3 pos)
		{
			return !WaterBlockBehaviour.Instance.IsEvaporated && !WaterBlockBehaviour.Instance.IsFrozen && pos.y < WaterBlockBehaviour.Instance.GlobalTop && pos.y > WaterBlockBehaviour.Instance.GlobalBottom && pos.x < WaterBlockBehaviour.Instance.GlobalRight && pos.x > WaterBlockBehaviour.Instance.GlobalLeft;
		}

		public static float GetWaterLevelOr(float fallback = -3.40282347E+38f)
		{
			if (!WaterBlockBehaviour.Instance)
			{
				return fallback;
			}
			if (WaterBlockBehaviour.Instance.IsEvaporated || WaterBlockBehaviour.Instance.IsFrozen)
			{
				return fallback;
			}
			return WaterBlockBehaviour.Instance.GlobalTop;
		}

		private void OnTriggerEnter2D(Collider2D collision)
		{
			if (!this.IsEvaporated && !this.IsFrozen)
			{
				this.DoSplash(collision);
			}
		}

		private void OnTriggerExit2D(Collider2D collision)
		{
			if (!this.IsEvaporated && !this.IsFrozen)
			{
				this.DoSplash(collision);
			}
		}

		private void DoSplash(Collider2D collision)
		{
			if (!UserPreferenceManager.Current.FancyEffects)
			{
				return;
			}
			if (collision.isTrigger)
			{
				return;
			}
			PhysicalBehaviour physicalBehaviour;
			if (!Global.main.PhysicalObjectsInWorldByTransform.TryGetValue(collision.transform, out physicalBehaviour))
			{
				return;
			}
			Rigidbody2D rigidbody = physicalBehaviour.rigidbody;
			GameObject gameObject = UnityEngine.Object.Instantiate<GameObject>(this.Splash, this.Trigger.bounds.ClosestPoint(collision.transform.position), Quaternion.identity);
			gameObject.SetActive(true);
			Vector2 velocity = rigidbody.velocity;
			velocity.y = -Mathf.Abs(velocity.y);
			gameObject.transform.up = Vector2.Reflect(velocity, Vector2.up);
			float num = Mathf.Min(collision.bounds.extents.x, 4f);
			float num2 = Mathf.Clamp(rigidbody.velocity.magnitude * 0.5f * rigidbody.mass, 0.2f, 25f);
			gameObject.GetComponent<AudioSource>().volume = num2 / 15f;
			foreach (ParticleSystem particleSystem in gameObject.GetComponentsInChildren<ParticleSystem>())
			{
				ParticleSystem.ShapeModule shape = particleSystem.shape;
				ParticleSystem.MainModule main = particleSystem.main;
				shape.radius = num;
				main.startSizeMultiplier = num * 2.5f * UnityEngine.Random.Range(1f, 1.4f);
				main.startSpeedMultiplier = num2;
			}
		}

		public void UpdateTemperatureState()
		{
			if (this.IsFrozen)
			{
				this.SetFrozen();
				return;
			}
			this.Ice.gameObject.SetActive(false);
			if (this.wasFrozen)
			{
				foreach (PhysicalBehaviour physicalBehaviour in this.frozenInIce)
				{
					if (!physicalBehaviour)
					{
						return;
					}
					FrozenInIceBehaviour obj;
					if (physicalBehaviour.TryGetComponent<FrozenInIceBehaviour>(out obj))
					{
						UnityEngine.Object.Destroy(obj);
						FreezeStackController.RequestUnfreeze(physicalBehaviour.rigidbody);
					}
				}
				this.wasFrozen = false;
			}
			this.frozenInIce.Clear();
			if (this.IsEvaporated)
			{
				this.SetEvaporated();
				return;
			}
			this.BoilingWaterSound.SetActive(PhysicalBehaviour.AmbientTemperature >= 100f);
			foreach (var renderer in base.GetComponents<Renderer>())
			{
				if (renderer != this.SpriteRenderer)
				{
					renderer.enabled = true;
				}
			}
			this.Trigger.enabled = true;
			this.Trigger.isTrigger = true;
			this.SpriteRenderer.enabled = true;
			GameObject[] objectsToBeActiveIfWater = this.ObjectsToBeActiveIfWater;
			for (int i = 0; i < objectsToBeActiveIfWater.Length; i++)
			{
				objectsToBeActiveIfWater[i].SetActive(true);
			}
		}

		private void SetEvaporated()
		{
			this.BoilingWaterSound.SetActive(false);
			foreach (var renderer in base.GetComponents<Renderer>())
			{
				if (renderer != this.SpriteRenderer)
				{
					renderer.enabled = false;
				}
			}
			this.Trigger.enabled = false;
			this.SpriteRenderer.enabled = false;
			GameObject[] objectsToBeActiveIfWater = this.ObjectsToBeActiveIfWater;
			for (int i = 0; i < objectsToBeActiveIfWater.Length; i++)
			{
				objectsToBeActiveIfWater[i].SetActive(false);
			}
		}

		private void SetFrozen()
		{
			this.BoilingWaterSound.SetActive(false);
			foreach (var renderer in base.GetComponents<Renderer>())
			{
				if (renderer != this.SpriteRenderer)
				{
					renderer.enabled = false;
				}
			}
			this.Ice.gameObject.SetActive(true);
			this.wasFrozen = true;
			this.Trigger.isTrigger = false;
			this.SpriteRenderer.enabled = true;
			GameObject[] objectsToBeActiveIfWater = this.ObjectsToBeActiveIfWater;
			for (int i = 0; i < objectsToBeActiveIfWater.Length; i++)
			{
				objectsToBeActiveIfWater[i].SetActive(false);
			}
			foreach (PhysicalBehaviour physicalBehaviour in Global.main.PhysicalObjectsInWorld)
			{
				if (!this.frozenInIce.Contains(physicalBehaviour))
				{
					int num = 0;
					int num2 = physicalBehaviour.LocalColliderGridPoints.Length;
					foreach (Vector2 v in physicalBehaviour.LocalColliderGridPoints)
					{
						if (physicalBehaviour.transform.TransformPoint(v).y <= this.GlobalTop && physicalBehaviour.transform.TransformPoint(v).y >= this.GlobalBottom && physicalBehaviour.transform.TransformPoint(v).x >= this.GlobalLeft && physicalBehaviour.transform.TransformPoint(v).y <= this.GlobalRight)
						{
							num++;
							if ((float)num / (float)num2 >= 0.1f)
							{
								physicalBehaviour.rigidbody.velocity = default(Vector2);
								physicalBehaviour.rigidbody.angularVelocity = 0f;
								FreezeStackController.RequestFreeze(physicalBehaviour.rigidbody);
								this.frozenInIce.Add(physicalBehaviour);
								physicalBehaviour.gameObject.AddComponent<FrozenInIceBehaviour>();
								physicalBehaviour.Temperature = Mathf.Min(physicalBehaviour.Temperature, PhysicalBehaviour.AmbientTemperature);
								break;
							}
						}
					}
				}
			}
		}

		private void FixedUpdate()
		{
			if (this.IsFrozen)
			{
				this.Ice.Temperature = PhysicalBehaviour.AmbientTemperature;
				foreach (PhysicalBehaviour physicalBehaviour in this.frozenInIce)
				{
					if (!physicalBehaviour)
					{
						return;
					}
					if (physicalBehaviour.OnFire)
					{
						physicalBehaviour.Extinguish();
					}
					FrozenInIceBehaviour obj;
					if (physicalBehaviour.transform.position.y > this.GlobalTop && physicalBehaviour.transform.position.y < this.GlobalBottom && physicalBehaviour.transform.position.y < this.GlobalRight && physicalBehaviour.transform.position.y > this.GlobalLeft && physicalBehaviour.TryGetComponent<FrozenInIceBehaviour>(out obj))
					{
						UnityEngine.Object.Destroy(obj);
						FreezeStackController.RequestUnfreeze(physicalBehaviour.rigidbody);
					}
				}
				return;
			}
			if (this.IsEvaporated)
			{
				return;
			}
			Vector3 a = Vector3.up * this.Buoyancy;
			float num = Mathf.Min(PhysicalBehaviour.AmbientTemperature, 100f);
			bool flag = PhysicalBehaviour.AmbientTemperature >= 100f;
			foreach (PhysicalBehaviour physicalBehaviour2 in Global.main.PhysicalObjectsInWorld)
			{
				if (!physicalBehaviour2)
				{
					break;
				}
				float num2 = Mathf.Clamp(Mathf.Pow(Mathf.Abs(physicalBehaviour2.transform.position.y - this.GlobalTop), 0.25f), 1f, 8f);
				float d = Mathf.Clamp01((num2 - 1f) / 7f) + 1f;
				Vector2 force = a * physicalBehaviour2.Properties.Buoyancy * physicalBehaviour2.rigidbody.mass / (float)physicalBehaviour2.LocalGridPointLength * num2;
				bool flag2 = false;
				physicalBehaviour2.CurrentWaterSurfaceLevel = this.GlobalTop;
				foreach (Vector2 v in physicalBehaviour2.LocalColliderGridPoints)
				{
					Vector3 vector = physicalBehaviour2.transform.TransformPoint(v);
					if (vector.y <= this.GlobalTop && vector.y >= this.GlobalBottom && vector.x <= this.GlobalRight && vector.x >= this.GlobalLeft)
					{
						flag2 = true;
						physicalBehaviour2.rigidbody.AddForceAtPosition(force, vector);
						Vector2 pointVelocity = physicalBehaviour2.rigidbody.GetPointVelocity(vector);
						physicalBehaviour2.rigidbody.AddForceAtPosition(-pointVelocity * d * this.GetDragFactor(pointVelocity) * physicalBehaviour2.rigidbody.mass * 0.4f, vector);
					}
				}
				bool flag3 = !physicalBehaviour2.IsUnderWater;
				physicalBehaviour2.IsUnderWater = flag2;
				if (flag2)
				{
					AliveBehaviour aliveBehaviour;
					if (flag && AliveBehaviour.AliveByTransform.TryGetValue(physicalBehaviour2.transform.root, out aliveBehaviour))
					{
						physicalBehaviour2.BurnProgress = Mathf.Max(physicalBehaviour2.BurnProgress, 0.5f);
						aliveBehaviour.SendMessage("AddPain", 15f, SendMessageOptions.DontRequireReceiver);
					}
					physicalBehaviour2.Temperature = Mathf.Lerp(physicalBehaviour2.Temperature, num, 0.05f * physicalBehaviour2.Properties.HeatTransferSpeedMultiplier);
					if (flag3 && physicalBehaviour2.Temperature >= 100f && physicalBehaviour2.Temperature > num * 2f)
					{
						physicalBehaviour2.PlayClipOnce(this.waterSizzles.PickRandom<AudioClip>(), 1f);
						physicalBehaviour2.Sizzle(false);
					}
					physicalBehaviour2.Wetness += 0.1f;
					physicalBehaviour2.SendMessage("WaterImpact", physicalBehaviour2.rigidbody.velocity.magnitude, SendMessageOptions.DontRequireReceiver);
					physicalBehaviour2.SendMessage("Suspended", SendMessageOptions.DontRequireReceiver);
				}
			}
		}

		private void Update()
		{
			UpdateTemperatureState();
		}

		private float GetDragFactor(Vector2 velocity)
		{
			float num = velocity.sqrMagnitude * 0.1f;
			return Mathf.Clamp(Mathf.Pow(num + 1f, num * this.Drag), 0.2f, 1f);
		}

		private void OnWillRenderObject()
		{
			if (!this.mat)
			{
				this.mat = this.SpriteRenderer.material;
			}
			if (this.mat)
			{
				this.mat.SetFloat("_Temperature", PhysicalBehaviour.AmbientTemperature);
			}
		}

		public float Drag;
		public float Buoyancy;
		public float GlobalTop;
		public float GlobalBottom;
		public float GlobalLeft;
		public float GlobalRight;
		public Vector2 WaterCenter;
		public Vector2 WaterSize;
		public bool Lava = false;
		public GameObject[] ObjectsToBeActiveIfWater;
		public GameObject Splash;
		public GameObject BoilingWaterSound;
		public SpriteRenderer SpriteRenderer;
		public Collider2D Trigger;
		public Collider2D[] insideWater = new Collider2D[1024];
		public LayerMask Layers;
		public PhysicalBehaviour Ice;
		private bool wasFrozen;
		private AudioClip[] waterSizzles;
		private HashSet<PhysicalBehaviour> frozenInIce = new HashSet<PhysicalBehaviour>();
		private Material mat;
		public static WaterBlockBehaviour Instance;
	}
}

